using System.Collections;
using System.Collections.Generic;
using UnityEngine;

/// <summary>
/// һ
/// </summary>
public class poolData
{
    //صĸڵ
    public GameObject fatherObj;
    //
    public List<GameObject> poolList;

    //캯
    public poolData(GameObject obj,GameObject poolObj)
    {
        //ǵһ󣬲ҰΪpool
        fatherObj = new GameObject(obj.name);
        fatherObj.transform.parent = poolObj.transform;

        poolList = new List<GameObject>() { obj };
        PushObj(obj); 
    }

    /// <summary>
    /// ѹ
    /// </summary>
    /// <param name="obj"></param>
    public void PushObj(GameObject obj)
    {
        //ʧ
        obj.SetActive(false);
        //
        poolList.Add(obj);
        //ø
        obj.transform.parent = fatherObj.transform;
    }

    /// <summary>
    /// ȡ
    /// </summary>
    /// <returns></returns>
    public GameObject GetObj()
    {
        GameObject obj = null;
        //ȡһ
        obj = poolList[0];
        poolList.RemoveAt(0);
        //ʾ
        obj.SetActive(true);
        //Ͽ
        obj.transform.parent = null;
        return obj;
    }
}

//ģ飬
//Dictionary List  ֵ 
//GameObjectResourcesAPI
public class PoolMgr :BaseManager<PoolMgr>
{
    //
    public Dictionary<string,poolData> poolDic = new Dictionary<string, poolData>();

    private GameObject poolObj;

    /// <summary>
    /// ö
    /// </summary>
    /// <param name="name"></param>
    /// <returns></returns>
    public GameObject GetObj(string name)
    {
        GameObject obj = null;
        //Ʒ
        if(poolDic.ContainsKey(name) && poolDic[name].poolList.Count > 0)
        {
            obj = poolDic[name].GetObj();
        }
        
        else
        {
            obj = GameObject.Instantiate(Resources.Load<GameObject>(name));
            //Ѷָĵúͳӵһ
            obj.name = name;
        }

        return obj;
    }

    /// <summary>
    /// ȥ
    /// </summary>
    public void PushObj(string name, GameObject obj)
    {
        if (poolObj == null)
        {
            poolObj = new GameObject("Pool");
        }
   
        //
        if (poolDic.ContainsKey(name))
        {
            poolDic[name].PushObj(obj);
        }
        //û
        else
        {
            //һlistֱӼӸƷȥ
            poolDic.Add(name, new poolData(obj,poolObj));
        }
    }

    /// <summary>
    /// ջأҪڳлʱ
    /// </summary>
    public void Clear()
    {
        poolDic.Clear();
        poolObj = null;
    }
}

